package org.rcisoft.sys.doorreportdata.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.rcisoft.sys.doorreportdata.entity.DoorReportData;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.aop.CyPageUtilAsp;
import org.rcisoft.core.model.CyPageInfo;

import java.util.List;

/**
 * Created by cy on 2022年12月23日 下午1:57:30.
 */
public interface DoorReportDataService {

    /**
    * 保存 门磁设备数据记录表
    * @param doorReportData
    * @return
    */
    CyPersistModel persist(DoorReportData doorReportData);

    /**
    * 删除 门磁设备数据记录表
    * @param doorReportData
    * @return
    */
    CyPersistModel remove(DoorReportData doorReportData);
    /**
    * 修改 门磁设备数据记录表
    * @param doorReportData
    * @return
    */
    CyPersistModel merge(DoorReportData doorReportData);

    /**
    * 根据id查询 门磁设备数据记录表
    * @param id
    * @return
    */
    DoorReportData findById(Long id);

    /**
    * 分页查询 门磁设备数据记录表
    * @param doorReportData
    * @return
    */
    IPage<DoorReportData> findAllByPagination(CyPageInfo<DoorReportData> paginationUtility,
              DoorReportData doorReportData);


    /**
    * 查询list 门磁设备数据记录表
    * @param doorReportData
    * @return
    */
    List<DoorReportData> findAll(DoorReportData doorReportData);


    /**
    * 导出门磁设备数据记录表
    * @return
    */
    List<DoorReportData> export(DoorReportData doorReportData);



}
