package org.rcisoft.sys.doorvideodevice.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.rcisoft.sys.doorvideodevice.entity.DoorVideoDevice;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.aop.CyPageUtilAsp;
import org.rcisoft.core.model.CyPageInfo;

import java.util.List;

/**
 * Created by cy on 2023年1月3日 上午10:29:41.
 */
public interface DoorVideoDeviceService {

    /**
    * 保存 视频监控设备信息
    * @param doorVideoDevice
    * @return
    */
    CyPersistModel persist(DoorVideoDevice doorVideoDevice);

    /**
    * 删除 视频监控设备信息
    * @param doorVideoDevice
    * @return
    */
    CyPersistModel remove(DoorVideoDevice doorVideoDevice);
    /**
    * 修改 视频监控设备信息
    * @param doorVideoDevice
    * @return
    */
    CyPersistModel merge(DoorVideoDevice doorVideoDevice);

    /**
    * 根据id查询 视频监控设备信息
    * @param id
    * @return
    */
    DoorVideoDevice findById(int id);

    /**
    * 分页查询 视频监控设备信息
    * @param doorVideoDevice
    * @return
    */
    IPage<DoorVideoDevice> findAllByPagination(CyPageInfo<DoorVideoDevice> paginationUtility,
              DoorVideoDevice doorVideoDevice);


    /**
    * 查询list 视频监控设备信息
    * @param doorVideoDevice
    * @return
    */
    List<DoorVideoDevice> findAll(DoorVideoDevice doorVideoDevice);


    /**
    * 导出视频监控设备信息
    * @return
    */
    List<DoorVideoDevice> export(DoorVideoDevice doorVideoDevice);

    /**
     * 根据设备ID获取设备信息
     * @param deviceId
     * @return
     */
    DoorVideoDevice getDeviceInfoById(Long deviceId);

    /**
     * 根据关联的门磁设备信息获取视频监控设备信息
     * @param deviceImei
     * @param linkId
     * @return
     */
    DoorVideoDevice getDeviceInfoByLinkId(String deviceImei,Long linkId);


}
