package org.rcisoft.sys.sysuser.entity;

import cn.afterturn.easypoi.excel.annotation.Excel;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.*;
import org.rcisoft.core.entity.CyIdIncreEntity;
import org.springframework.data.annotation.Transient;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;

/**
 * Created with cy on 2022年11月16日 下午3:19:18.
 */
@Data
@TableName("sys_user")
public class SysUser extends CyIdIncreEntity<SysUser> {


    //树级部门
    @Transient
    private List<Integer> deptSJ;

    @Excel(name = "所属园区", orderNum = "22", width = 20)
    //地址中文
    private String addressLabel;

    //职位中文
    private String positionLabel;

    //班次中文
    private String nltBzLabel;

    //角色中文名
    @Transient
    private String roleName;

    //分支
    @Transient
    private String fenZhi;

    //权重
    @Transient
    private Integer dictSort;

    //角色
    @Transient
    private List roleList;

    //角色
    @Transient
    private String role;

    //班次中文名
    @Transient
    private String dictLabelBynltBz;

    //职位中文名
    @Transient
    private String dictLabelByPosition;

    //部门名称
    @Transient
    private String deptName;

    //排序
//    @Transient
    private String sort;

    @Transient
    private String px;

    /**
     * 开始时间
     */
    @Transient
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private String beginTime;

    //结束时间
    @Transient
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private String endTime;

    //字典类型
    @Transient
    private String dictType;

    /**
     * 用户的guid
     */
    private String personId;

    /**
     * @desc 登录名
     * @column username
     * @default
     * @default
     */
//    @Excel(name = "登录名", orderNum = "0", width = 20)
    private String username;

    /**
     * @desc 用户昵称
     * @column nick_name
     * @default
     * @default
     */
//    @Excel(name = "用户昵称", orderNum = "1", width = 20)
    private String nickName;

    /**
     * @desc 用户类型（0内部员工 1外部访客）
     * @column user_type
     * @default
     * @default
     */
//    @Excel(name = "用户类型（0内部员工 1外部访客）", orderNum = "2", width = 20)
    private String userType;

    /**
     * @desc 用户姓名
     * @column name
     * @default
     * @default
     */
    @Excel(name = "用户姓名", orderNum = "3", width = 20)
    private String name;

    /**
     * @desc 用户邮箱
     * @column email
     * @default
     * @default
     */
//    @Excel(name = "用户邮箱", orderNum = "4", width = 20)
    private String email;

    /**
     * @desc 手机号码
     * @column phone
     * @default
     * @default
     */
    @Excel(name = "手机号码", orderNum = "5", width = 20)
    private String phone;

    /**
     * @desc 用户性别（0女 1男）
     * @column sex
     * @default
     * @default
     */
    @Excel(name = "用户性别", orderNum = "6", width = 20)
    private String sex;


    /**
     * @desc 是否显示考勤（0是 1否）
     * @column attendance_show
     * @default 0
     */
    private String attendanceShow;

    /**
     * @desc 密码
     * @column password
     * @default
     * @default
     */
//    @Excel(name = "密码", orderNum = "7", width = 20)
    private String password;

    /**
     * @desc 身份证号
     * @column id_number
     * @default
     * @default
     */
//    @Excel(name = "身份证号", orderNum = "8", width = 20)
    private String idNumber;

    /**
     * @desc 头像地址
     * @column avatar
     * @default
     * @default
     */
//    @Excel(name = "头像地址", orderNum = "9", width = 20)
    private String avatar;

    /**
     * @desc 最后登录ip
     * @column login_ip
     * @default
     * @default
     */
//    @Excel(name = "最后登录ip", orderNum = "10", width = 20)
    private String loginIp;

    /**
     * @desc 最后登录时间
     * @column login_date
     * @default
     * @default
     */
//    @Excel(name = "最后登录时间", orderNum = "11", width = 20)
    private Date loginDate;

    /**
     * @desc 所属部门id
     * @column dept_id
     * @default
     * @default
     */
    @Excel(name = "所属部门", orderNum = "12", width = 20)
    private String deptId;

    /**
     * @desc 身份（1普通员工 2管理员 3外部访客）
     * @column identity
     * @default
     * @default
     */
//    @Excel(name = "身份", orderNum = "13", width = 20)
    private String identity;

    /**
     * @desc 微信id
     * @column wx_openid
     * @default
     * @default
     */
//    @Excel(name = "微信id", orderNum = "14", width = 20)
    private String wxOpenid;

    /**
     * @desc wx地址
     * @column wx_address
     * @default
     * @default
     */
//    @Excel(name = "wx地址", orderNum = "15", width = 20)
    private String wxAddress;

    /**
     * @desc wx头像
     * @column wx_head
     * @default
     * @default
     */
//    @Excel(name = "wx头像", orderNum = "16", width = 20)
    private String wxHead;

    /**
     * @desc wx性别
     * @column wx_sex
     * @default
     * @default
     */
//    @Excel(name = "wx性别", orderNum = "17", width = 20)
    private String wxSex;

    /**
     * @desc wx昵称
     * @column wx_nick_name
     * @default
     * @default
     */
//    @Excel(name = "wx昵称", orderNum = "18", width = 20)
    private String wxNickName;

    /**
     * @desc 班次
     * @column nlt_bz
     * @default
     * @default
     */
    @Excel(name = "班次", orderNum = "19", width = 20)
    private String nltBz;

    /**
     * @desc 职位（暂时数据字典，可能多个）
     * @column position
     * @default
     * @default
     */
    @Excel(name = "职位", orderNum = "20", width = 20)
    private String position;

    /**
     * @desc 入职时间
     * @column nlt_start_date
     * @default
     * @default
     */
//    @Excel(name = "入职时间", orderNum = "21", width = 20)
    private Date nltStartDate;

    /**
     * @desc 地址
     * @column address
     * @default
     * @default
     */
//    @Excel(name = "所属园区", orderNum = "22", width = 20)
    private String address;

    /**
     * @desc 人脸信息（可能第三方图片数据）
     * @column face_address
     * @default
     * @default
     */
    private String faceAddress;

    // 管理员状态（0停，1起）
    private String glFlag;

    /**
     * @desc 黑名单状态（0不存在1存在）
     * @column blacklist_flag
     * @default
     * @default
     */
//    @Excel(name = "黑名单状态（0不存在1存在）", orderNum = "24", width = 20)
    private Long blacklistFlag;

    // 首次到访
    @JsonFormat(pattern = "yyyy-MM-dd  HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date firstDate;

    @JsonFormat(pattern = "yyyy-MM-dd  HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @TableField(exist = false)
    private Date firstDateQueryStart;

    @JsonFormat(pattern = "yyyy-MM-dd  HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @TableField(exist = false)
    private Date firstDateQueryEnd;
//
//    private Date[] firstDateQuery;

    // 最近到访
    @JsonFormat(pattern = "yyyy-MM-dd  HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date lastDate;

    @JsonFormat(pattern = "yyyy-MM-dd  HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @TableField(exist = false)
    private Date lastDateQueryStart;

    @JsonFormat(pattern = "yyyy-MM-dd  HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @TableField(exist = false)
    private Date lastDateQueryEnd;
//
//    private Date[] lastDateQuery;

    // 到访次数
    @TableField(exist = false)
    private int count;
}


