package org.rcisoft.sys.sysusercard.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.rcisoft.sys.sysusercard.entity.SysUserCard;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.aop.CyPageUtilAsp;
import org.rcisoft.core.model.CyPageInfo;

import java.util.List;

/**
 * Created by cy on Dec 28, 2022, 2:07:15 PM.
 */
public interface SysUserCardService {

    /**
    * 保存 人员凭证记录表
    * @param sysUserCard
    * @return
    */
    CyPersistModel persist(SysUserCard sysUserCard);

    /**
    * 删除 人员凭证记录表
    * @param sysUserCard
    * @return
    */
    CyPersistModel remove(SysUserCard sysUserCard);
    /**
    * 逻辑删除 人员凭证记录表
    * @param sysUserCard
    * @return
    */
    CyPersistModel removeLogical(SysUserCard sysUserCard);
    /**
    * 修改 人员凭证记录表
    * @param sysUserCard
    * @return
    */
    CyPersistModel merge(SysUserCard sysUserCard);

    /**
    * 根据id查询 人员凭证记录表
    * @param id
    * @return
    */
    SysUserCard findById(int id);

    /**
    * 分页查询 人员凭证记录表
    * @param sysUserCard
    * @return
    */
    IPage<SysUserCard> findAllByPagination(CyPageInfo<SysUserCard> paginationUtility,
              SysUserCard sysUserCard);


    /**
    * 查询list 人员凭证记录表
    * @param sysUserCard
    * @return
    */
    List<SysUserCard> findAll(SysUserCard sysUserCard);


    /**
    * 导出人员凭证记录表
    * @return
    */
    List<SysUserCard> export(SysUserCard sysUserCard);

    /**
     * 根据用户ID或捷顺用户ID删除用户凭证记录
     * @param userId
     * @param personId
     * @return
     */
    void delUserCardByUserId(Long userId,String personId);


}
