package org.rcisoft.sys.visit.dao;

import org.rcisoft.core.mapper.CyBaseMapper;
import org.rcisoft.core.model.CyPageInfo;
import org.apache.ibatis.annotations.Param;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.rcisoft.sys.visit.entity.VisitInfoMation;
import org.rcisoft.sys.visit.entity.VisitUser;

import java.util.List;

/**
* Created with cy on 2022年11月16日 下午2:40:21.
*/

public interface VisitInfomationRepository extends CyBaseMapper<VisitInfoMation> {


    List<VisitInfoMation> queryVisitInfomations(@Param("entity") VisitInfoMation visitInfomation);

    /**
    * 分页查询 visitInfomation
    *
    */
    IPage<VisitInfoMation> queryVisitInfomationsPaged(CyPageInfo cyPageInfo,@Param("entity") VisitInfoMation visitInfomation);

    /**
     * wx分页查询 visitInfomation
     *
     */
    IPage<VisitInfoMation> queryVisitInfomationsByUserIdPaged(CyPageInfo cyPageInfo,@Param("entity") VisitInfoMation visitInfomation,@Param("userId")int userId);


    List<VisitInfoMation> queryVisitList(@Param("entity") VisitInfoMation visitInfomation);

    VisitInfoMation queryVisitById(@Param("id") int id);

    /**
     * 根据手机号匹配最新受邀记录
     * @param phone
     * @return
     */
    List<VisitInfoMation> lastDetail(@Param("phone") String phone);


    /**
     * 获取过去的邀访信息
     * **/
    List<VisitInfoMation> queryPast(int userId);

    /**
     * 获取未来的邀访信息
     * **/
    List<VisitInfoMation> queryFuture(int userId);

    List<VisitUser> getUserList(@Param("business_id") int business_id);

    List<VisitInfoMation> findByUser(VisitUser visitUser);

    List<VisitInfoMation> findByTime(@Param("time")String time,@Param("realTime")String realTime);
}

