package org.rcisoft.sys.visit.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import org.rcisoft.sys.visit.dto.ImportVistInfoDTO;
import org.rcisoft.sys.visit.entity.VisitInfoMation;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.model.CyPageInfo;
import org.rcisoft.sys.visit.entity.VisitUser;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.text.ParseException;
import java.util.List;

/**
 * Created by cy on 2022年11月16日 下午2:40:21.
 */
public interface VisitInfomationService {

    /**
    * 保存 邀访信息
    * @param visitInfomation
    * @return
    */
    CyPersistModel persist(VisitInfoMation visitInfomation);

    /**
    * 删除 邀访信息
    * @param visitInfomation
    * @return
    */
    CyPersistModel remove(VisitInfoMation visitInfomation);

    CyPersistModel forbidden(VisitInfoMation visitInfoMation);
    /**
    * 逻辑删除 邀访信息
    * @param visitInfomation
    * @return
    */
    CyPersistModel removeLogical(VisitInfoMation visitInfomation);
    /**
    * 修改 邀访信息
    * @param visitInfomation
    * @return
    */
    CyPersistModel merge(VisitInfoMation visitInfomation);

    /**
    * 根据id查询 邀访信息
    * @param id
    * @return
    */
    VisitInfoMation findById(int id);

    /**
    * 分页查询 邀访信息
    * @param visitInfomation
    * @return
    */
    IPage<VisitInfoMation> findAllByPagination(CyPageInfo<VisitInfoMation> paginationUtility,
                                               VisitInfoMation visitInfomation);
      /**
    * wx小程序分页查询 邀访信息
    * @param visitInfomation 查询条件
    * @return
    */
    IPage<VisitInfoMation> findAllWithUserIdByPagination(CyPageInfo<VisitInfoMation> paginationUtility,
                                               VisitInfoMation visitInfomation, HttpServletRequest request);




    /**
    * 查询list 邀访信息
    * @param visitInfomation
    * @return
    */
    List<VisitInfoMation> findAll(VisitInfoMation visitInfomation);


    /**
    * 导出邀访信息
    * @return
    */
    List<VisitInfoMation> export(VisitInfoMation visitInfomation);

    /**
     * 查询当前登录人最新首要记录
     * @return
     */
    VisitInfoMation lastDetail(HttpServletRequest request);

    List<VisitInfoMation> getPastOrFutureInfo(HttpServletRequest request);

    int exportEmptyTemplate(HttpServletResponse response);

    ImportVistInfoDTO importUserExcel(MultipartFile file,HttpServletResponse response) throws ParseException;

    /**
     * 根据访客信息查询邀访信息
     * @param
     * @return
     */
    List<VisitInfoMation> findByUser(VisitUser visitUser);

    int download(String fileName, HttpServletResponse response) throws Exception;

    CyPersistModel persistWX(VisitInfoMation visitInfomation);
}
