//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by FernFlower decompiler)
//

package org.rcisoft.sys.sysuser.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;

import java.util.Date;
import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.rcisoft.core.exception.CyServiceException;
import org.rcisoft.core.jwt.util.CyJwtUtil;
import org.rcisoft.core.result.enums.CyReSysExcEnum;
import org.rcisoft.core.result.enums.CyResSvcExcEnum;
import org.rcisoft.core.service.CyAuthService;
import org.rcisoft.core.threadpool.CyAsyncFactory;
import org.rcisoft.core.threadpool.CyAsyncManager;
import org.rcisoft.core.util.CyServletUtil;
import org.rcisoft.core.util.CyAddressUtils.IpUtils;
import org.rcisoft.sys.log.entity.SysLoginInfo;
import org.rcisoft.sys.rbac.user.dao.SysUserRbacRepository;
import org.rcisoft.sys.sysuser.dao.SysUserRepositorys;
import org.rcisoft.sys.sysuser.service.CyAuthServices;
import org.rcisoft.sys.wbac.user.dao.SysUserRepository;
import org.rcisoft.sys.wbac.user.entity.SysUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.security.authentication.AuthenticationManager;
import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

@Service
@Transactional(
        readOnly = true,
        propagation = Propagation.NOT_SUPPORTED
)
@ConditionalOnProperty(
        prefix = "cy.model.security",
        name = {"enable"},
        havingValue = "true"
)
public class CyAuthServicesImpl implements CyAuthServices {
    @Value("${cy.model.permission}")
    private String permission;
    @Value("${cy.model.loginLog:}")
    private Boolean loginLog;
    @Autowired
    private AuthenticationManager authenticationManager;
    @Autowired(
            required = false
    )
    private SysUserRepository sysUserRepository;
    @Autowired(
            required = false
    )
    private SysUserRbacRepository sysUserRbacRepository;
    @Autowired
    private PasswordEncoder passwordEncoder;
    @Autowired
    private SysUserRepositorys sysUserRepositorys;

    public CyAuthServicesImpl() {
    }

    @Transactional(
            propagation = Propagation.REQUIRED,
            readOnly = false
    )
    public void register(SysUser userToAdd) {
        QueryWrapper<SysUser> wrapper = new QueryWrapper();
        List<SysUser> sysUser = this.sysUserRepository.selectList(wrapper);
        if (sysUser.size() > 0) {
            throw new CyServiceException(CyResSvcExcEnum.USER_EXISTS);
        } else {
            userToAdd.setPassword(this.passwordEncoder.encode(userToAdd.getPassword()));
            int result = this.sysUserRepository.insert(userToAdd);
            if (result == 0) {
                throw new CyServiceException(CyReSysExcEnum.FAIL);
            }
        }
    }

    public String login(String username, String password) {
        org.rcisoft.sys.sysuser.entity.SysUser sysUser = sysUserRepositorys.querySysUsersByUname(username);
        if (sysUser.getFlag() != null) {
            String flag = sysUser.getFlag();
            if (flag.equals("3")) {
                throw new CyServiceException(1111, "该账户已被停用");
            }
        }
        UsernamePasswordAuthenticationToken upToken = new UsernamePasswordAuthenticationToken(username, password);
        Authentication authentication = null;
        SysLoginInfo sysLoginInfo = new SysLoginInfo();
        String ip = IpUtils.getIpAddr(CyServletUtil.getRequest());
        sysLoginInfo.setIpaddr(ip);
        sysLoginInfo.setUsername(username);
        sysLoginInfo.setLoginTime(new Date());

        try {
            authentication = this.authenticationManager.authenticate(upToken);
        } catch (Exception var9) {
            if (this.loginLog) {
                sysLoginInfo.setMsg(StringUtils.substring(var9.getMessage(), 0, 2000));
                sysLoginInfo.setFail();
                CyAsyncManager.me().execute(CyAsyncFactory.recordLoad(sysLoginInfo));
            }

            throw var9;
        }

        if (this.loginLog) {
            sysLoginInfo.setSuccess();
            CyAsyncManager.me().execute(CyAsyncFactory.recordLoad(sysLoginInfo));
        }

        UserDetails userDetails = (UserDetails) authentication.getPrincipal();
        String token = CyJwtUtil.generateToken(userDetails);
        SecurityContextHolder.getContext().setAuthentication(authentication);

        return token;
    }

    public String refresh(String oldToken) {
        return null;
    }
}
